#lang racket

(require "mauxa.rkt")
(require math/base math/number-theory)

;;;; 11. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 3.5.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - nekonečné streamy,
;;;; - metainterpreter programovacieho jazyka LISP.
;;;; Zadanie sa skladá z týchto súborov:
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 4
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 8.5.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
;; (define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Streamy.

;;; Sekcia. Nekonečné streamy.

;;; Podsekcia. Implementácia.

;; [Lisp] Pozri modul v súbore mauxa.rkt.

;; (require "mauxa.rkt")

;; Definícia.
;; Ak s je stream, tak symbolom range(s) označujeme množinu jeho prvkov. Vravíme
;; tiež, že stream s enumeruje množinu range(s). Ak v streame s sa nevyskytujú
;; rovnaké prvky, tak ide o enumeráciu bez opakovania. Stream často nefomálne
;; popisujeme vymenovaním niektorých jeho prvkov:
;;   s = (s[0], s[1], s[2], ..., s[i], ...).
;; Tu s[0] je prvý prvok streamu s, s[1] je druhý prvok streamu s, atď.

;;; Podsekcia. [Lisp]

;; Táto časť slúži pre ladenie. Nehodnotí sa!

;; Náhodný generátor (nekonečných) streamov celých čísel.

(define (random-integer-stream m n)
  (cons-stream (random-integer m n)
               (random-integer-stream m n)))

;; Aplikácia stream->list(n,s) vráti zoznam prvých n prvkov streamu s.

(define (stream->list n s)
  (if (= n 0)
      '()
      (cons (stream-car s)
            (stream->list (- n 1) (stream-cdr s)))))

;; (stream->list 10 (random-integer-stream 0 10))

;;; Podsekcia. Príklady jednoduchých streamov.

;; Príklad z minulého cvičenia.
;; Stream, ktorý enumeruje množinu prirodzených čísel N v prirodzenom poradí.

(define natural-numbers ...)

;; (stream->list 10 natural-numbers)

;;; Podsekcia. Základné operácie na streamoch.

;; Príklad z minulého cvičenia.
;; Program, ktorý počíta indexovaciu funkciu na streamoch. Indexuje sa od nuly.
;;   M-syntax: s[i].

(define (stream-ref s i) ...)

;; (let ([s (random-integer-stream 0 10)] [i 5]) (writeln (stream->list 10 s)) (writeln (stream-ref s i)))

;; Príklad z minulého cvičenia.
;; Program pre funkcionál stream-map, ktorý funguje na streamoch podobne ako
;; funkcionál map na zoznamoch.

(define (stream-map proc s) ...)

;; (stream->list 10 (stream-map (λ (x) (* x x)) natural-numbers))

;;; Podsekcia. Množinové operácie na streamoch.

;; Pokyny. V nasledujúcich príkladoch nepoužívajte párovaciu funkciu.

;; Definícia.
;; Nech A a B sú číselne množiny a nech ≺ je lineárne usporiadanie na A × B.
;; Vravíme, že ≺ je monotónne v oboch argumentoch, ak
;;   x1 < x2 → (x1,y) ≺ (x2,y)
;;   y1 < y2 → (x,y1) ≺ (x,y2)
;; pre každé x,x1,x2 ∈ A a y,y1,y2 ∈ B. 

;; Úloha.
;; Zostrojte program pre funkciu ordered-pairs(s1,s2,≺), ktorá vytvorí
;; ≺-usporiadaný karteziánsky súčin pre danú dvojicu rastúcich číselných
;; streamov:
;;   range ordered-pairs(s1,s2,≺) = range(s1) × range(s2).
;;   i < j → ordered-pairs(s1,s2,≺)[i] ≺ ordered-pairs(s1,s2,≺)[j]
;; Tu ≺ je lineárne usporiadanie na range(s1) × range(s2) monotónne v oboch
;; argumentoch.
;;   Návod. Pozri cvičenie 3.70 v [1].

(define (merge-streams s1 s2 ≺) ...)
(define (ordered-pairs s1 s2 ≺) ...)

;; (1 bod)
;; Úloha.
;; Zostrojte stream, ktorý enumeruje karteziánsky súčin N×N týmto spôsobom:
;;     |  0  1  2  3  4
;;   -------------------
;;   0 |  1  2  4  7 11
;;   1 |  3  5  8 12 17
;;   2 |  6  9 13 18 24
;;   3 | 10 14 19 25 32
;;   4 | 15 20 26 33 41
;; Pokyny. Stream implementujte pomocou ordered-pairs pre vhodné usporiadanie.

(define ($≺1 x y) ...)
(define natural-numbers×natural-numbers1 ...)

;; (stream->list 20 natural-numbers×natural-numbers1)

;; (1 bod)
;; Úloha.
;; Zostrojte stream, ktorý enumeruje karteziánsky súčin N×N týmto spôsobom:
;;     |  0  1  2  3  4
;;   -------------------
;;   0 |  1  2  5 10 17
;;   1 |  3  4  6 11 18
;;   2 |  7  8  9 12 19
;;   3 | 13 14 15 16 20
;;   4 | 21 22 23 24 25
;; Pokyny. Stream implementujte pomocou ordered-pairs pre vhodné usporiadanie.

(define ($≺2 x y) ...)
(define natural-numbers×natural-numbers2 ...)

;; (stream->list 20 natural-numbers×natural-numbers2)

;;; Podsekcia. Ďalšie operácie na streamoch.

;; (1 bod)
;; Úloha.
;; Zostrojte program, ktorý vyhodí duplikáty zo streamu. Predpokladajte, že
;; vstupný stream enumeruje nekonečnú množinu.

(define (no-doubles s) ...)

;; (define multiples-of-two-or-three (stream-map (λ (x) (if (divides? 2 x) (* 2 (quotient x 2)) (* 3 (quotient x 2)))) natural-numbers))
;; (stream->list 10 multiples-of-two-or-three)
;; (stream->list 10 (no-doubles multiples-of-two-or-three))

;; (1 bod)
;; Úloha.
;; Zostrojte program pre predikát member?(x,s1,s2), ktorý testuje príslušnosť
;; prvku x v streame s1. Tu s2 je stream, ktorý enumeruje komplement množiny
;; range(s1).

(define (member? x s1 s2) ...)

;; (member? 0 (stream-map (λ (x) (* 2 x)) natural-numbers) (stream-map (λ (x) (+ (* 2 x) 1)) natural-numbers))
