#lang racket

;;;; 11. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 3.5.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - nekonečné streamy,
;;;; - metainterpreter programovacieho jazyka LISP.
;;;; Zadanie sa skladá z týchto súborov:
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 3-4
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 10 (cvičenie 4.31 v [1])
;;;; Odovzdať do 8.5.2016 (nedeľa).
;;;; Projekt odovzdať do 15.5.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
;; (define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define apply-in-underlying-scheme apply)
(require scheme/mpair)

;;; Kapitola. Metainterpreter programovacieho jazyka LISP.

;;; Sekcia. Vyhodnocovanie výrazov v prostredí väzieb.

;;; Podsekcia. Aritmetizácia.

;; Rozlišovacie položky zoznamových konštruktorov.

(define (tagged-list? exp tag)
  (and (pair? exp)
       (equal? (car exp) tag)))

;; Aritmetizácia výrazov (schéma). 

(define (make-<variant> ...) (list '<variant> ...))     ; konštruktor
(define (<variant>? exp) (tagged-list? exp '<variant>)) ; predikát
(define (<variant>-<selector> exp) ...)                 ; selektor(y)
(define (eval-<variant> exp env) ...)                   ; vyhodnocovanie

;;; Podsekcia. Vyhodnocovanie výrazov v prostredí väzieb.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

;; Operácia my-eval(exp,env) vyhodnotí výraz exp v prostredí väzieb env.

(define (my-eval exp env)
  (cond [(<variant>? exp) (eval-<variant> exp env)]
        [else (error "Unknown expression type -- EVAL" exp)]))

;;; Podsekcia. Operácie nad prostredím väzieb.

;; Základné operácie.

(define the-empty-environment '())
(define (empty-environment? env) (null? env))
(define (enclosing-environment env) (mcdr env))
(define (first-frame env) (mcar env))
(define the-empty-frame '())
(define (binding-value binding) (mcdr binding))

;; Modifikácia prostredia väzieb.

(define (set-first-frame! env frame) (set-mcar! env frame))
(define (set-binding-value! binding val) (set-mcdr! binding val))

;; Rozšírenie prostredia väzieb.

(define (make-environment frame env)
  (mcons frame env))

(define (add-to-frame-let binding frame)
  (mcons (mcons (car binding) (cadr binding)) frame))

(define (add-to-frame-apply var val frame)
  (mcons (mcons var val) frame))

(define (extend-environment-let bindings env)
  (define (loop bindings frame)
    (if (null? bindings)
        (make-environment frame env)
        (loop (cdr bindings) (add-to-frame-let (car bindings) frame))))
  (loop bindings the-empty-frame))

(define (extend-environment-apply vars vals env)
  (define (loop vars vals frame)
    (if (and (null? vars) (null? vals))
        (make-environment frame env)
        (loop (cdr vars) (cdr vals) (add-to-frame-apply (car vars) (car vals) frame))))
  (loop vars vals the-empty-frame))

;; Globálne prostredie väzieb.

(define (make-primitive-procedure proc)
  (list (string->symbol "primitive procedure") proc))

(define frame-of-primitive-procedures
  (mlist
   (mcons 'zero? (make-primitive-procedure zero?))
   (mcons '+ (make-primitive-procedure +))
   (mcons '- (make-primitive-procedure -))
   (mcons '* (make-primitive-procedure *))
   (mcons 'quotient (make-primitive-procedure quotient))
   (mcons 'remainder (make-primitive-procedure remainder))
   (mcons '= (make-primitive-procedure =))
   (mcons '<= (make-primitive-procedure <=))
   (mcons '< (make-primitive-procedure <))
   (mcons '>= (make-primitive-procedure >=))
   (mcons '> (make-primitive-procedure >))
   (mcons '... (make-primitive-procedure undefined))
   (mcons 'null (make-primitive-procedure null))
   (mcons 'null? (make-primitive-procedure null?))
   (mcons 'cons (make-primitive-procedure cons))
   (mcons 'pair? (make-primitive-procedure pair?))
   (mcons 'car (make-primitive-procedure car))
   (mcons 'cdr (make-primitive-procedure cdr))
   (mcons '#t (make-primitive-procedure #t))
   (mcons '#f (make-primitive-procedure #f))
   ))

(define the-global-environment
  (make-environment frame-of-primitive-procedures the-empty-environment))

;;; Podsekcia. Samo vyhodnocujúce sa výrazy.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Premenné.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma if (podmienkové výrazy).

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

(define (eval-if exp env) ...)

;;; Podsekcia. Špeciálna forma let (priradenie do lokálnej premennej).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma set! (priradenie).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma begin (postupnosť výrazov).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma define (definície).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma lambda (operátor abstrakcie).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Aplikatívne výrazy.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

(define (eval-application exp env) ...)

;;; Podsekcia. Programy.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

(define (my-apply proc args env) ...)

;;; Podsekcia. Prostredie pre lenivé vyhodnocovanie.

;; Operácie na modifikovateľných dvojiciach.

(define (mcadr x) ...)
(define (mcaddr x) ...)

;; Rozlišovacie položky zoznamových konštruktorov.

(define (tagged-mlist? exp tag)
  (and (mpair? exp)
       (equal? (mcar exp) tag)))

;; Operácia actual-value(exp,env) vyhodnotí výraz exp v prostredí väzieb env.

(define (actual-value exp env) ...)

;; Konštruktor(y).

(define (delay-it exp env) (mlist 'thunk exp env)) ;; alternatívny názov make-thunk
(define (make-evaluated-thunk obj) (mlist 'evaluated-thunk obj))

;; Predikát(y).

(define (thunk? obj) ...)
(define (evaluated-thunk? obj) ...)

;; Selektor(y).

(define (thunk-exp thunk) ...)
(define (thunk-env thunk) ...)
(define (thunk-value evaluated-thunk) ...)

;; Vyhodnocovanie.

(define (force-it obj) ...)

;; Testovanie.

;; (my-eval '(define (infinite-loop x) (foo x)) the-global-environment)
;; (my-eval '(define (fst-proj x y) x) the-global-environment)
;; the-global-environment
;; (my-eval '(fst-proj 1 (infinite-loop 2)) the-global-environment)
;; (actual-value '(fst-proj 1 (infinite-loop 2)) the-global-environment)
;; (my-eval '(+ (fst-proj 1 (infinite-loop 2)) 3) the-global-environment)
;; (actual-value '(+ (fst-proj 1 (infinite-loop 2)) 3) the-global-environment)

;; (my-eval '(define (zeros x) (if (= x 0) null (cons 0 (zeros (- x 1))))) the-global-environment)
;; (my-eval '(define (fst-proj x y) x) the-global-environment)
;; the-global-environment
;; (time (actual-value '(fst-proj 1 (zeros 300000)) the-global-environment))
;; (define (zeros x) (if (= x 0) null (cons 0 (zeros (- x 1)))))
;; (time (car (zeros 300000)))
